const express = require("express");
const router = express.Router();
const authorize = require("../../../../middlewares/authorize-sapps");
const budgetDepartmentService = require("./budgetDepartment.service");
const redisClient = require('../../../../redisClient');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.post('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.put('/enabled/:id', authorize(), enabled);
router.delete('/:id', authorize(), _delete);

module.exports = router;

function create(req, res, next) {
    budgetDepartmentService
        .create(req.body)
        .then((result) => res.json(result))
        .catch(next);
}

function getAll(req, res, next) {
    budgetDepartmentService
        .getAll(req.body)
        .then((result) => res.json(result))
        .catch(next);
}

function option(req, res, next) {
    budgetDepartmentService
        .option(req.body)
        .then((result) => res.json(result))
        .catch(next);
}

function count(req, res, next) {
    budgetDepartmentService
        .count(req.body)
        .then((result) => res.json(result))
        .catch(next);
}

function update(req, res, next) {
    budgetDepartmentService
        .update(req.params.id, req.body)
        .then((result) => res.json(result))
        .catch(next);
}

function enabled(req, res, next) {
    budgetDepartmentService
        .enabled(req.params.id, req.body)
        .then((result) => res.json(result))
        .catch(next);
}

function _delete(req, res, next) {
    budgetDepartmentService
        .delete(req.params.id)
        .then((result) => res.json(result))
        .catch(next);
}
